<?php
namespace Teknisa\CADEST\Services;

use Teknisa\CADEST\Factories\ProdTreeGroup as ProdTreeGroupFactory;
use Teknisa\Libs\Util\Environment;

class ProdTreeGroup {

    protected $ProdTreeGroupFactory;
    protected $nrorg;

    function __construct(ProdTreeGroupFactory $ProdTreeGroupFactory, Environment $environment) {
        $this->ProdTreeGroupFactory = $ProdTreeGroupFactory;
        $this->nrorg = $environment->getNrorgTrab();
    }

    public function getAllGroupsByParents($row) { 
        $rowToBack = $row;

        foreach ($row as $value) {
            $childrenGroup = array();

            $childrenGroup = $this->getChildren($value);
            
            $rowToBack = array_merge($rowToBack, $childrenGroup);
        }

        return $rowToBack;
    }

    function getChildren($parent) {
        $params = array("NRARVOREPRODPAI"=>$parent, "NRORG"=>$this->nrorg);
        $children = $this->ProdTreeGroupFactory->getChildren($params);

        if (count($children) > 0) {
            $children = array_map(function ($value) {
                return $value['NRARVOREPROD'];
            }, $children);
            $childrenChildren = array();
            foreach ($children as $value) {
                $childrenChildren = array_merge($childrenChildren, $this->getChildren($value));
            }
            return array_merge($childrenChildren, $children);
        } else {
            return array();
        }
    }

    

}
